#!/usr/bin/python
# Coding=utf-8
# mainmenu modul for minescape

"""Mainmenu modul for minescape"""

import os,sys,pygame,time,pickle

global version
global mbuttons
global activebutton
global gamerunning
global windows
global screenbuffer
global music
global music_on
activebutton=0
music_on=0
buttoncolor=[202,83,191]
buttontextcolor=[255,255,0]
highscores=[]

music=pygame.mixer.Sound(os.path.join("sounds","Medieval Dream.ogg"))

class button:
    """Class for menubuttons"""
    def __init__(self,x=0,y=0,color=[0,0,0],text='',textcolor=[255,255,255]):
        self.width=300
        self.height=50
        self.x=x
        self.y=y
        self.color=color
        self.rect=pygame.Rect(self.x,self.y,self.width,self.height)
        self.text=text
        self.surf=pygame.Surface((self.width,self.height))
        self.textcolor=textcolor
        self.font=pygame.font.Font(os.path.join('graphics','DejaVuSans-Bold.ttf'),self.height-2*self.height/5)

    def display(self,screen):
        self.surf.fill(self.color)
        self.stext=self.font.render(self.text,1,self.textcolor)
        self.textpos=self.stext.get_rect()
        self.textpos.center=(self.width/2,self.height/2)
        self.surf.blit(self.stext,self.textpos)
        screen.blit(self.surf,self.rect)
        pygame.display.flip()

class window:
    """Class for mainmenu windows"""
    def __init__(self,windowname,width,height,color,textcolor=[0,0,0],bgimage=None,content=[], px=18,l=0): #content is a list, depends on content type
        self.windowname=windowname
        self.width=width
        self.height=height
        self.color=color
        self.surf=pygame.Surface((width,height))
        self.rect=pygame.Rect((1024-width)/2,(768-height)/2,width,height)
        if bgimage<>None:
            bgfile=os.path.join('graphics',bgimage)
            self.bgimage=pygame.image.load(bgfile).convert_alpha()
        else:
            self.bgimage=None
        self.textcolor=textcolor
        self.font=pygame.font.Font(os.path.join('graphics','DejaVuSans-Bold.ttf'),25)
        self.textsurf=self.font.render(self.windowname,1,self.textcolor)
        self.textrec=self.textsurf.get_rect()
        self.textrec.center=(self.width/2,45)
        self.font2=pygame.font.Font(os.path.join('graphics','DejaVuSans.ttf'),14)
        self.lowertext=self.font2.render("Hit Esc or Q to go back",1,self.textcolor)
        self.lowertextrect=self.lowertext.get_rect()
        self.lowertextrect.center=(self.width/2,self.height-25)
        self.content=content
        self.px=px
        self.l=l
        if content<>[]:
            self.contenttype=content[0] # 1=text, 0=no content
            self.content.pop(0)
        else:
            self.contenttype=0
    
    def content_display(self,screen):
        pos_y=100
        height=self.px+int((self.px*0.4)/2)
        if self.contenttype==0:
            return
        if self.contenttype==1: # the content is text, let's display it
            for line in self.content:
                cfont=pygame.font.Font(os.path.join('graphics','DejaVuSans.ttf'),self.px)
                cline=cfont.render(line,1,self.textcolor)
                crect=cline.get_rect()
                if self.l==1:
                    crect.topleft=(self.width*0.25,pos_y)
                else:
                    crect.center=(self.width/2,pos_y)
                self.surf.blit(cline,crect)
                pos_y=pos_y+height
            
    def display(self,screen):
        if self.bgimage<>None:
            self.surf=self.bgimage
        else:
            self.surf.fill(self.color)
        self.surf.blit(self.textsurf,self.textrec)
        self.surf.blit(self.lowertext,self.lowertextrect)
        self.content_display(screen)
        screen.blit(self.surf,self.rect)
        pygame.display.flip()
        
def background(screen):
    """Function to init mainmenu background."""
    bgfile=os.path.join('graphics',"minescape_background.png")
    bgimg=pygame.image.load(bgfile)
    bgrect=bgimg.get_rect()
    screen.blit(bgimg,bgrect)
    pygame.display.flip()

def buttons(screen):
    "Function for generating and displaying the menubuttons"
    global mbuttons
    menubuttontext=["Start Game","Help","High Scores","About","Quit"]
    mbuttons=[]
    i=0
    for mbtext in menubuttontext:
        mbuttons.append(button(650,220+i*65,buttoncolor,mbtext,buttontextcolor))
        mbuttons[i].display(screen)
        i=i+1

def footer(screen):
    "Generating and displaying menuscreen's footer."
    global version
    footerfont=pygame.font.Font(os.path.join('graphics','DejaVuSans-Bold.ttf'),14)
    footertext=footerfont.render("Created by siPYgames 2009 "+version,1,(255,191,0))
    footerpos=footertext.get_rect()
    footerpos.center=(screen.get_width()/2,screen.get_height()-30)
    screen.blit(footertext,footerpos)
    pygame.display.flip()

def inithighscores():
    "This function generates the default highscore table"
    global highscores
    highscores.append(["Barney",2000])
    highscores.append(["Giselle",1800])
    highscores.append(["Digbot",1400])
    highscores.append(["Arnold",1200])
    highscores.append(["Hacker",1000])
    highscores.append(["Sergei",800])
    highscores.append(["Osama",600])
    highscores.append(["Superman",500])
    highscores.append(["Warrior",400])
    highscores.append(["Python",250])
    file=open("highscores.bin","wb")
    pickle.dump(highscores,file)
    file.close()
    
def createwindows():
    "Generating subwindows for particular menuitems"
    global windows,highscores
    windows=[]
    i=0
    if os.path.isfile("highscores.bin"):
        hf=open("highscores.bin","rb")
        highscores=pickle.load(hf)
        hf.close()
    else:
        print "mainmenu: inithighscores"
        inithighscores()
    highscoresstringlist=[1]
    n=1
    for item in highscores:
        highscoresstringlist.append(str(n)+". -  "+item[0]+"  -  "+str(item[1]))
        n+=1
    windownames=[["Help",600,600,(0,0,143),(255,255,255),"help.png",[1, \
    "Help Barney to escape from the bombed mine. Control him", \
    "with the cursor arrows. To avoid the bombs Barney gets", \
    "some help on each field around him similarly as in a normal", \
    "minesweeper game. These hints indicates how many bombs", \
    "can be found around them.", \
    "", \
    "Barney has three type of tools what also help on his tour:", \
    "", \
    "Flags - Barney can put flags on fields to remember him there", \
    "should be a bomb on that field. To plant a flag, press 'F' and", \
    "an arrow for the direction you want to place the flag.", \
    "", \
    "Dropweights - Barney can throw off 10 tons weight to break", \
    "3x3 fields into pieces. This action destroy all the bombs", \
    "inside that 3x3 square if any. To drop the weight press 'D'", \
    "and an arrow for the direction of the drop.", \
    "", \
    "Digbots - Barney can send out a digbot from the bottom row", \
    "on higher levels. The bot automatically digs forward and", \
    "clears the fields until it steps on a bomb or reach the wall", \
    "To release a bot, press 'B' when Barney in the bottom line.", \
    "",\
    "And remember: Barney also need to beat the clock!"], 16], \
    ["High Scores",600,600,(0,0,143),(255,240,0),"help.png",highscoresstringlist,30,1], \
    ["About",400,400,(255,223,191),(237,191,146),"about.png",[1,"Mine Escape","The new way of minesweeping","Created by sIPYgames","2009.","Developer: sipiatti","Homepage: coming soon..."," ","Mainmenu music by","Butterfly Tea, Jamendo.com"]]]
    for wins in windownames:
        windows.append(window(*wins))

def menumusic():
    "Starting menumusic if pygame.mixer has been inited"
    global music_on,music
    if pygame.mixer.get_init()<>None:
        music.set_volume(0.4)
        if music_on<>1:
            music.play(-1)
            music_on=1
    
def display(screen):
    "Displaying the menu"
    background(screen)
    buttons(screen)
    footer(screen)
    createwindows()
    menumusic()
    mbuttons[activebutton].color=buttontextcolor
    mbuttons[activebutton].textcolor=buttoncolor
    mbuttons[activebutton].display(screen)

def menuup(screen,buttons):
    "Handler to move in menu (up)"
    global activebutton
    oldbutton=activebutton
    if activebutton>0:
        activebutton=activebutton-1
        mbuttons[oldbutton].color=buttoncolor
        mbuttons[oldbutton].textcolor=buttontextcolor
        mbuttons[oldbutton].display(screen)
        mbuttons[activebutton].color=buttontextcolor
        mbuttons[activebutton].textcolor=buttoncolor
        mbuttons[activebutton].display(screen)
        pygame.display.update()

def menudown(screen,buttons):
    "Handler to move in menu (down)"
    global activebutton
    oldbutton=activebutton
    if activebutton<buttons:
        activebutton=activebutton+1
        mbuttons[oldbutton].color=buttoncolor
        mbuttons[oldbutton].textcolor=buttontextcolor
        mbuttons[oldbutton].display(screen)
        mbuttons[activebutton].color=buttontextcolor
        mbuttons[activebutton].textcolor=buttoncolor
        mbuttons[activebutton].display(screen)
        pygame.display.update()

def actions(screen,activebutton):
    "Handling menu actions"
    screenbuffer=screen.copy()
    windows[activebutton-1].display(screen)
    slots={pygame.K_1:1,pygame.K_2:2,pygame.K_3:3,pygame.K_4:4}
    while 1:
        event=pygame.event.wait()
        if event.type == pygame.QUIT : sys.exit()
        if event.type == pygame.KEYDOWN and event.key in [pygame.K_ESCAPE, pygame.K_q]:
            screen.blit(screenbuffer,screen.get_rect())
            pygame.display.flip()
            return

def handle(screen):
    "Central menuhandler function"
    global activebutton
    action=""
    buttons=len(mbuttons)-1
    activebutton=0
    while 1:
        event=pygame.event.wait()
        if event.type == pygame.QUIT or (event.type == pygame.KEYDOWN and event.key in [pygame.K_ESCAPE, pygame.K_q]):
            action="EXIT"
            return action
        if event.type==pygame.KEYDOWN:
            if event.key==pygame.K_UP:
                menuup(screen,buttons)
            elif event.key==pygame.K_DOWN:
                menudown(screen,buttons)
            elif event.key==pygame.K_RETURN:
                if activebutton==buttons:
                    action="EXIT"
                    return action
                elif activebutton==0:
                    action="START"
                    return action
                else:
                    actions(screen,activebutton)